
# ********************************************************************************************************************************
# ******************************** GENERACIÓN DE TABULADO NACIONAL- ENCUESTA ESTRUCTURAL EMPRESARIAL *****************************
# ********************************************************************************************************************************

# ********************************************************************** #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# Fuente: Encuesta Estructural Empresarial 2024                          #
# Responsable: Unidad de Gestión de Estadísticas Estructurales (GESE)    #
# ********************************************************************** #
# Fecha de elaboración: 18/11/2022                                       #
# Fecha última modificación: 23/02/2026                                  #
# ********************************************************************** #
# Elaborado por:                                                         #
# Gestión de Estadísticas Estructurales - GESE                           #
# Instituto Nacional de Estadística y Censos                             #
# ********************************************************************** #
# Revisado por                                                           #
# Roberto Chaves                                                         #
# Jefe de Gestión de Estadísticas Estructurales                          #
# Instituto Nacional de Estadística y Censos                             #
# roberto_chaves@inec.gob.ec                                             #
# ********************************************************************** #
# Aprobado por:                                                          #
# Diana Barco                                                            #
# Directora de Estadísticas Económicas (DECON)                           #
# Instituto Nacional de Estadística y Censos                             #
# Diana_Barco@inec.gob.ec                                                #
##########################################################################



#========================================================================#
# FUNCIÓN                                                                #
#========================================================================#

"Carga de librerías"

enesem_lib <- function(libreria) {
  if (!requireNamespace(as.character(libreria), quietly = TRUE)) {
    install.packages(as.character(libreria))
  }
  library(libreria, character.only = TRUE)
}


#========================================================================#
# CARGAR LIBRERIAS                                                       #
#========================================================================#

enesem_lib("openxlsx")
enesem_lib("dplyr")
enesem_lib("rio")
enesem_lib("Hmisc")
enesem_lib("tidyverse")
enesem_lib("haven")
enesem_lib("janitor") 

#Establecer la dirección de trabajo.

"Estimado Usuario. Por favor en el disco C: de su computadora, crear una carpeta llamada Tabulados Estructural, y coloque la BDD de la encuesta, sintaxis llamada 
2024_ENESEM_Sintaxis_Tabulados_Nacional y el archivo Tabulado_Nacional_Estilo.xlsx
En esta carpeta se exportarán los resultados de los tabulados."

setwd("C:/Tabulados Estructural")

#Abrir directorio.
dir()

# *** Llamar base de datos****

data <-  read_sav("2024_ESTRUCTURAL_EMPRESARIAL_BDD.sav") #En caso de haber editado el nombre de la BDD reemplazarlo en esta línea
# data <-  read_delim("2024_ESTRUCTURAL_EMPRESARIAL_BDD.csv",delim = ";", escape_double = FALSE, trim_ws = TRUE) #En caso de que se descargue la base de datos en formato csv, quitar comentario (#) de esta línea de código y comentar (#) el comando read_sav.

#seteando directorio de Servicios#
"Se generará una nueva carpeta dentro de Tabulados Estructurales donde se exportarán los documentos excel de tabulados"

dir.create ("TOMOI-TABULADOS")


# CUADRO 8. INDICADORES DE RELACIÓN

dataC8 <- select(data, cod_letra, cant_ener, des_letra, cod_tamano, des_tamano, prodtota, totalpeoc, valag, f_exp)
dataC8 <- mutate_if(dataC8, is.numeric, ~ .* dataC8$f_exp)

# *C8-SECCIÓN
# 8-1
C8_1 <- filter(dataC8, prodtota>0 & totalpeoc>0)
C8_1 <- C8_1 %>%  group_by(cod_letra, des_letra)%>%
  summarise(prodtota_sum=(sum(prodtota, na.rm = T)),totalpeoc_sum=(sum(totalpeoc, na.rm = T))) %>%
  mutate(prodpo=(prodtota_sum/totalpeoc_sum))

# 8-2
C8_2 <- filter(dataC8, valag>0 & totalpeoc>0)
C8_2 <- C8_2 %>%  group_by(cod_letra, des_letra) %>%
  summarise(valag_sum=(sum(valag, na.rm = T)), totalpeoc_sum=(sum(totalpeoc, na.rm = T))) %>%
  mutate(valagpo=valag_sum/totalpeoc_sum)


# **** Unificación de indicadores
C8S1 <- full_join(C8_1, C8_2, by="cod_letra")
C8S <- select(C8S1, cod_letra, des_letra.x, prodpo, valagpo)
rm(C8S1)
names(C8S) <- c("Sección CIIU Rev. 4.0", "Descripción", "Producción por persona ocupada", "Valor agregado por persona ocupada")


# *Cálculo de totales
k11 <- c(colSums(C8_1[,3]))
k12 <- c(colSums(C8_1[,4]))
k21 <- c(colSums(C8_2[,3]))
k22 <- c(colSums(C8_2[,4]))
k1 <- ((k11/k12))
k2 <- ((k21/k22))
k8N <- as.data.frame(t(c(NA, k1, k2)))
k8N[1,1] <- "Total Nacional"

rm(k11, k12, k21, k22, k1, k2)
names(k8N) <- c( " ", "Producción por persona ocupada", "Valor agregado por persona ocupada")

# ============================================================================ #
#####               DISEÑO Y EXPORTACIÓN DE TABULADOS A EXCEL              ##### 
# ============================================================================ #
"En esta sección se diseñara y exportara los tabulados en formato excel"

##### Configuración tabulados #####

plantilla <- loadWorkbook("Tabulado_Nacional_Estilo.xlsx")

#tabulado 1
writeData(plantilla,
          "Total Nacional",
          k8N, 
          startRow = 4, 
          startCol = 2,  
          colNames = FALSE)

setwd("TOMOI-TABULADOS")

saveWorkbook(plantilla, "Tabulado_Nacional.xlsx",overwrite = TRUE )


# En el caso de que se presente la advertencia: "First argument must be a Workbook"
# por favor, ejecute las siguientes líneas y vuelva a correr el código anterior.

# detach("package:rio", unload=TRUE)
# detach("package:openxlsx", unload=TRUE)
# install.packages("openxlsx", "rio")
# library(openxlsx)



